;;; ASDF system definition for Graph.
(defpackage :graph-system
    (:use :asdf :common-lisp))

(in-package :graph-system)

(defparameter *graph-directory* (directory-namestring *load-truename*))

(format t "graph-directory is ~A ~%" *graph-directory*)

(defsystem :graph
  :description "Graph: library of operations on graphs"
  :name "graph"
  :version "1.0"
  :author ""
  :licence "General Public Licence"
  :depends-on (:io)
  :serial t
  :components ((:file "package-graph-model")
	       (:file "label")
	       (:file "number")
	       (:file "weight")
	       (:file "mark")
	       (:file "utilities")
	       (:file "arc")
	       (:file "node")
	       (:file "graph-model")
	       (:file "package-graph-io")
	       (:file "graph-io")
	       (:file "package")
	       ))

(pushnew :graph *features*)
